package de.oaa.xxx.games.common.aufgaben;

import java.util.List;
import java.util.UUID;

import de.oaa.xxx.games.bdsm.BdsmMitspieler;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class Strafe {

    private UUID strafeId;
    private Integer level;
    private String text;
    private String kurzText;
    private Integer sekundenVon;
    private Integer sekundenBis;
    private UUID gruppeId;
    private List<Werkzeug> benoetigtAktiv;
    private List<Werkzeug> benoetigtPassiv;
    private List<Toy> benoetigteToys;

    public boolean isAufgabePassend(int level, BdsmMitspieler aktiv, BdsmMitspieler passiv) {
        if (level != this.level && level - 1 != this.level) {
            return false;
        }
        if (benoetigtPassiv != null) {
            for (Werkzeug werkzeug : benoetigtPassiv) {
                if (!passiv.isVerfuegbar(werkzeug)) {
                    return false;
                }
            }
        }
        if (benoetigtAktiv == null || benoetigtAktiv.isEmpty()) {
            return true;
        } else {
            for (Werkzeug werkzeug : benoetigtAktiv) {
                if (aktiv.isVerfuegbar(werkzeug)) {
                    return true;
                }
            }
            return false;
        }
    }
}
